#include <stdio.h>
unsigned char han24[1],han48[1],han16[1];
#include "jfc.c"
#define n1 2048
float a[n1],b[n1],c[n1],d[n1];
FILE *fp;

float xmed2(b,n,i1,c)
float *b; int n,i1,c;
{
  int i,j,k,i2;
  float a[999],x;                     // alway in odd
// adjust window
  int j1,j2;
  j1=j2=c;
  k=2*i1+1;     if(k<c)j1=k;
  k=(n-i1)*2-1; if(k<c)j2=k;
  j=(j1>j2)?j2:j1; if(j<9)j=9;        // assume min_window is 9
// adjust window end
  k=j/2;
  i2=i1-k; if(i2<0)i2=0;
  if(i1+k>=n-1)i2=n-j-1;
  for(i=0;i<j;i++)a[i]=b[i2+i];
  sortx1(a,j);
  x=a[k];
  return(x);
}
float xmea2(b,n,i1,c)                       // smooth
float *b; int n,i1,c;
{
  int i,j,k,i2;
  float x;                            // alway in odd
// adjust window
  int j1,j2;
  j1=j2=c;
  k=2*i1+1;     if(k<c)j1=k;
  k=(n-i1)*2-1; if(k<c)j2=k;
  j=(j1>j2)?j2:j1; if(j<3)j=3;        // assume min_window is 3
// adjust window end
  k=j/2;
  i2=i1-k; if(i2<0)i2=0;
  if(i1+k>=n-1)i2=n-j-1;
  x=0.; for(i=0;i<j;i++)x+=b[i2+i];
  return(x/j);
}
sortx1(a,n)
float *a; int n;
{
  int i,j,k=2,ii,ifin;
  float x;
  while(k<n)k*=2;
  k=(3*k)/4-1; if(n<k)k=n;
l20:
  k/=2;        ifin=n-k;
  for(ii=0;ii<ifin;ii++){
    i=ii;      j=i+k;
    if(a[i]<=a[j])continue;
    x = a[j];
l40:
    a[j]= a[i];
    j=i;       i-=k;
    if(i<0)goto l60;
    if(a[i]>x)goto l40;
l60:
    a[j]=x;
  }
  if(k>1)goto l20;
}

main(int ac, char **av)
{
  int i,j,k,v99,v2,m1,m2;
  float x,y,x1[2],y1[2];
  float fk;
  float A,B,C;
  if(ac<3){ printf("\n\t *** plot smooth line of p4.c ***\n");
            printf("\n\t after: p4 flatfile datafile 2");
            printf("\n\t(p4 f5922_3.fit e5922_0206_3.fit 2)\n");
            printf("\n\t platv99 v99.3 200 [600,1600] (150-400)\n\n");
    exit(0); }
  fp=fopen(av[1],"rb"); if(!fp){ printf("\n\t%s not found!\n",av[1]);exit(0);}
  fread(a,4,n1,fp); fclose(fp);
  sscanf(av[2],"%d",&v99);   v2=v99/2;  m1=n1-1;
  
  x=0; for(i=0;i<n1;i++){ b[i]=i; x+=a[i]; } x/=n1;
  x1[0]=100; x1[1]=400;
  jfbegin("",552,300,45);
//  jfenv(0.-80,2048.+80.,x,x+15,2);  jflush();
  jfenv(0.-80,2048.+80.,x-25,x+15,2);  jflush();
  jflabel("pixel","adu","smooth 1/4_CCD (one gate) sky background");
  jflp(1); for(i=0;i<n1;i++)if(a[i]>x-25 && a[i]<x+15)jfpoint(b[i],a[i]);
  else { printf("out of frame: %d %f\n",i,a[i]); jfpoint(b[i],a[i]); }  

  for(i=0;i<n1;i++)c[i]=xmea2(a,n1,i,v99);      
  jfsci(2); for(i=0;i<n1;i++)jfpoint(b[i],c[i]+0);  // mean, not use
  y1[0]=y1[1]=x-10; jfline(2,x1,y1); jftext(600.,y1[0]+1,"mean (not use)");

  for(i=0;i<n1;i++)c[i]=xmed2(a,n1,i,v99);          // meadian  step1
  jfsci(6); for(i=0;i<n1;i++)jfpoint(b[i],c[i]+4); 
  y1[0]=y1[1]=x-13; jfline(2,x1,y1); jftext(500.,y1[0]+1,"step1: median");



  for(i=0;i<n1;i++)d[i]=xmea2(c,n1,i,v99);          // mean     step2
//for(i=0;i<n1;i++){ printf(" %d %f",i,d[i]); if(i%5==0)printf("\n"); }
  jfsci(4); for(i=0;i<n1;i++)jfpoint(b[i],d[i]+6); 
  y1[0]=y1[1]=x-16; jfline(2,x1,y1); jftext(500.,y1[0]+1,"step2: mean");

  fk=(d[v2*2]-d[v2])/v2;       for(i=0;i<v2;i++)d[i]=fk*(i-v2)+d[v2];
  fk=(d[m1-v2*2]-d[m1-v2])/v2; for(i=n1-v2;i<n1;i++)d[i]=fk*(m1-v2-i)+d[m1-v2];
  jfsci(1); for(i=0;i<n1;i++)jfpoint(b[i],d[i]+8);  // modify_2_end   step3
  y1[0]=y1[1]=x-19; jfline(2,x1,y1); 
  jftext(500,y1[0]+1,"step3: process 2_end, last output");
  jfsci(2); jflp(4);
  jfpoint(b[v2],d[v2]+8);
  jfpoint(b[2*v2],d[2*v2]+8);
  jfpoint(b[m1-v2],d[m1-v2]+8);
  jfpoint(b[m1-2*v2],d[m1-2*v2]+8);

  jflp(1); m2=2*v2;                                 // modi_2_end use 2nd_curve
  abc_d(d[m2-v2],d[m2],d[m2+v2],m2,v2,&A,&B,&C);    // not use
  for(i=0;i<v2;i++)d[i]=A*i*i+B*i+C;

  m2=m1-2*v2;
  abc_d(d[m2-v2],d[m2],d[m2+v2],m2,v2,&A,&B,&C);
  for(i=n1-v2;i<n1;i++)d[i]=A*i*i+B*i+C;
  jfsci(14); for(i=0;i<n1;i++)jfpoint(b[i],d[i]+10);  // modify 2 end 3
  y1[0]=y1[1]=x-22; jfline(2,x1,y1); 
  jftext(600,y1[0]+1,"2_curve fit END, (not use)");
  jfsci(2); jflp(4);
             jfpoint(b[v2],d[v2]+10);
             jfpoint(b[2*v2],d[2*v2]+10);
             jfpoint(b[3*v2],d[3*v2]+10);
        m2=m1-v2;  
             jfpoint(b[m2],d[m2]+10);
             jfpoint(b[m2-v2],d[m2-v2]+10);
             jfpoint(b[m2-2*v2],d[m2-2*v2]+10);
  
// test insert routine
  if(ac>3){
    sscanf(av[2],"%d",&i);
    sscanf(av[3],"%d",&j);
    jflp(1);
    insert(d,i,j);
    for(i=0;i<n1;i++)jfpoint(b[i],d[i]+10);  
  }

  jflush(); scanf("%s",&k); jfend(0);
}

insert(d,i1,i2)       
float *d; int i1,i2;              // av fix1 point  0.00~0.25
{                                 // av fix2 point  0.75~1.00
  int i,m;                        // linear insert
  float x,p1,p2,y;
  m=(i2-i1)*0.25;
  p1=0; for(i=i1;i<i1+m;i++)p1+=d[i]; p1/=m;
  p2=0; for(i=i2-m;i<i2;i++)p2+=d[i]; p2/=m;
  x=(p2-p1)/(3*m);
  for(i=i1+m/2;i<i2-m/2;i++){
    y=d[i]-(x*(i-i1-m*0.5)+p1);
    d[i]-=y;
  }
  printf("insert: %d ~ %d (0.125~0.875)\n",i1+m/2,i2-m/2);
}

abc_d(y1,y2,y3,x2,d,A,B,C)
float y1,y2,y3,*A,*B,*C; int x2,d;
{
  float a,b,c;
// y1=A*(x2-d)**2+B*(x2-d)+C  (1)
// y2=A*x2**2    +B*x2    +C  (2)
// y3=A*(x2+d)**2+B*(x2+d)+C  (3)
// (1)+(3)-2*(2)
  a=(y1+y3-2*y2)/(2*d*d);
// (3)-(1)
  b=(y3-y1-4*a*x2*d)/(2*d);
// (2)
  c=y2-a*x2*x2-b*x2;
  *A=a; *B=b; *C=c;
  printf("A,B,C: %f %f %f\n",a,b,c);
}
